void mousePressed() {
  if(show_individual){
    for (int i=0; i<countries.size(); i++) {
      float distance = dist(mouseX, mouseY, screenPos[i].x, screenPos[i].y);
      // Detect if the distance is small enough to trigger the hover effect
      if (distance<20) {
        // if the distance is the smallest among all the candidates distance
        countries.get(hover_index).should_display = !countries.get(hover_index).should_display;
      }
    }
    print(countries.get(hover_index).should_display);
  }
  
  cam.beginHUD();
  int textPos = horMargin;
  if (textPos<mouseX&&mouseX<textPos+140) {
    if (mouseY>verMargin+16*0-8+90-20+100&&mouseY<verMargin+16*0+8+90-20+100) {
      show_earth = ! show_earth;
    }
    if (mouseY>verMargin+16*1-8+90-20+100&&mouseY<verMargin+16*1+8+90-20+100) {
      draw_line = ! draw_line;
    }
    if (mouseY>verMargin+16*2-8+90-20+100&&mouseY<verMargin+16*2+8+90-20+100) {
      draw_self_consumption = ! draw_self_consumption;
    }
    if (mouseY>verMargin+16*3-8+90-20+100&&mouseY<verMargin+16*3+8+90-20+100) {
      if(!show_individual){
         draw_mesh = ! draw_mesh;
      }
    }
    if (mouseY>verMargin+16*4-8+90-20+100&&mouseY<verMargin+16*4+8+90-20+100) {
      show_individual = ! show_individual;
      draw_mesh= false;
      if(show_individual){
        for(int i = 0; i < countries.size(); ++i){
          countries.get(i).should_display = false;
        }
      }else{
        for(int i = 0; i < countries.size(); ++i){
          countries.get(i).should_display = true;
        }
      }
    }
  }
  
 if (textPos<mouseX&&mouseX<textPos+140) {
    if (mouseY>verMargin+330+2+5+18*0+38&&mouseY<verMargin+330+2+5+18*1+38) {
      show_rice=!show_rice;
    }

    if (mouseY>verMargin+330+2+5+18*1+38&&mouseY<verMargin+330+2+5+18*2+38) {
      show_wheat=!show_wheat;
    }

    if (mouseY>verMargin+330+2+5+18*2+38&&mouseY<verMargin+330+2+5+18*3+38) {
      show_other_cereal=!show_other_cereal;
    }

    if (mouseY>verMargin+330+2+5+18*3+38&&mouseY<verMargin+330+2+5+18*4+38) {
      show_vegitable=!show_vegitable;
    }

    if (mouseY>verMargin+330+2+5+18*4+38&&mouseY<verMargin+330+2+5+18*5+38) {
      show_oil=!show_oil;
    }

    if (mouseY>verMargin+330+2+5+18*5+38&&mouseY<verMargin+330+2+5+18*6+38) {
      show_sugar=!show_sugar;
    }
  }

  cam.endHUD();
}