void gui() {
  hint(DISABLE_DEPTH_TEST);
  cam.beginHUD();
  //cp5.draw();
  //-----------------------------
  //title
  //-----------------------------
  fill(230);
  textAlign(LEFT);
  textFont(font);
  textSize(60);
  text("Cultivation of Energy", horMargin, verMargin);
  textSize(20);
  text("Using countries' supply and consumption data from EXIOBase to illustrate the shape formed by crops.", 
    horMargin, verMargin+30);


  //-----------------------------
  //name
  //-----------------------------
  fill(200);
  textAlign(LEFT, CENTER);
  textSize(16);
  text("Junxiang Yao", horMargin, verMargin+70);
  text("Winter 2018", horMargin, verMargin+88);
  //text("Student Defined Visualization", horMargin, verMargin+106);


  textAlign(LEFT, CENTER);
  fill(200);
  textSize(20);
  text("Control", 
    horMargin, verMargin+72-22+100);
  rectMode(CORNER);
  for (int i = 0; i < 5; i++) {
    if (horMargin<mouseX&&mouseX<horMargin+140) {
      if (mouseY>verMargin+18*i-6+90-20+100&&mouseY<verMargin+18*i+6+90-20+100) {
        if(i != 3){
          noStroke();
          fill(200, 50);
          rect(horMargin, verMargin+16*i-6+90-21+100, 140, 14);
        }else{
          if(!show_individual){
            noStroke();
            fill(200, 50);
            rect(horMargin, verMargin+16*i-6+90-21+100, 140, 14);
          }
        }
      }
    }
  }

  if (show_earth) {
    noStroke();
    fill(255, 80);
    rect(horMargin, verMargin+16*0-6+90-21+100, 140, 14);
  }
  
  if (draw_line) {
    noStroke();
    fill(255, 80);
    rect(horMargin, verMargin+16*1-6+90-21+100, 140, 14);
  }
  if (draw_self_consumption) {
    noStroke();
    fill(255, 80);
    rect(horMargin, verMargin+16*2-6+90-21+100, 140, 14);
  }
  if (draw_mesh) {
    noStroke();
    fill(255, 80);
    rect(horMargin, verMargin+16*3-6+90-21+100, 140, 14);
  }
  
  if (show_individual) {
    noStroke();
    fill(255, 80);
    rect(horMargin, verMargin+16*4-6+90-21+100, 140, 14);
  }

  textAlign(LEFT, CENTER);
  textSize(14);
  fill(220);
  text("Earth", horMargin+1, verMargin + 16*0 + 90-22+100);
  text("Export Line", horMargin+1, verMargin + 16*1 + 90-22+100);
  text("Self Consumption", horMargin+1, verMargin + 16*2 + 90-22+100);
  text("Mesh", horMargin+1, verMargin + 16*3 + 90-22+100);
  text("Individual Mode", horMargin+1, verMargin + 16*4 + 90-22+100);
  
    //-----------------------------
  //color legend
  //-----------------------------
  //if (showLegend) {
    if (show_rice) {
      noStroke();
      fill(rice_color, 100);
      rectMode(CORNER);
      rect(horMargin, verMargin+330+2+5+18*0+38, 140, 15);
    }
    if (show_wheat) {
      noStroke();
      fill(wheat_color, 100);
      rectMode(CORNER);
      rect(horMargin, verMargin+330+2+5+18*1+38, 140, 15);
    }

    if (show_other_cereal) {
      noStroke();
      fill(other_cereal_color, 100);
      rectMode(CORNER);
      rect(horMargin, verMargin+330+2+5+18*2+38, 140, 15);
    }

    if (show_vegitable) {
      noStroke();
      fill(vegitable_color, 100);
      rectMode(CORNER);
      rect(horMargin, verMargin+330+2+5+18*3+38, 140, 15);
    }

    if (show_oil) {
      noStroke();
      fill(oil_color, 100);
      rectMode(CORNER);
      rect(horMargin, verMargin+330+2+5+18*4+38, 140, 15);
    }
  
    if (show_sugar) {
      noStroke();
      fill(sugar_color, 100);
      rectMode(CORNER);
      rect(horMargin, verMargin+330+2+5+18*5+38, 140, 15);
    }
  










  if (horMargin<mouseX&&mouseX<horMargin+140) {
    if (mouseY>verMargin+330+2+5+18*0+38&&mouseY<verMargin+330+2+5+18*1+38) {
      noStroke();
      fill(rice_color, 50);
      rectMode(CORNER);
      rect(horMargin, verMargin+330+2+5+18*0+38, 140, 15);
    }
  }
  if (horMargin<mouseX&&mouseX<horMargin+140) {
    if (mouseY>verMargin+330+2+5+18*1+38&&mouseY<verMargin+330+2+5+18*2+38) {
      noStroke();
      fill(wheat_color, 50);
      rectMode(CORNER);
      rect(horMargin, verMargin+330+2+5+18*1+38, 140, 15);
    }
  }
  if (horMargin<mouseX&&mouseX<horMargin+140) {
    if (mouseY>verMargin+330+2+5+18*2+38&&mouseY<verMargin+330+2+5+18*3+38) {
      noStroke();
      fill(other_cereal_color, 50);
      rectMode(CORNER);
      rect(horMargin, verMargin+330+2+5+18*2+38, 140, 15);
    }
  }
  if (horMargin<mouseX&&mouseX<horMargin+140) {
    if (mouseY>verMargin+330+2+5+18*3+38&&mouseY<verMargin+330+2+5+18*4+38) {
      noStroke();
      fill(vegitable_color, 50);
      rectMode(CORNER);
      rect(horMargin, verMargin+330+2+5+18*3+38, 140, 15);
    }
  }
  if (horMargin<mouseX&&mouseX<horMargin+140) {
    if (mouseY>verMargin+330+2+5+18*4+38&&mouseY<verMargin+330+2+5+18*5+38) {
      noStroke();
      fill(oil_color, 50);
      rectMode(CORNER);
      rect(horMargin, verMargin+330+2+5+18*4+38, 140, 15);
    }
  }
  if (horMargin<mouseX&&mouseX<horMargin+140) {
    if (mouseY>verMargin+330+2+5+18*5+38&&mouseY<verMargin+330+2+5+18*6+38) {
      noStroke();
      fill(sugar_color, 50);
      rectMode(CORNER);
      rect(horMargin, verMargin+330+2+5+18*5+38, 140, 15);
    }
  }
  fill(200);
  textSize(14);
  textAlign(LEFT, CENTER);
  text("Paddy Rice", 
    horMargin + 6, verMargin+330+1+50);
  text("Wheat", 
    horMargin + 6, verMargin+348+1+50);
  text("Other Cereal Grains", 
    horMargin + 6, verMargin+366+1+50);
  text("Vegitable, fruit, nuts", 
    horMargin + 6, verMargin+384+1+50);
  text("Oil Seeds", 
    horMargin + 6, verMargin+402+1+50);
  text("Sugar Cane, Beet", 
    horMargin + 6, verMargin+420+1+50);
  rectMode(CENTER);
  fill(rice_color); 
  noStroke(); 
  rect(horMargin + 1, verMargin+330+2+50, 2, 15);
  fill(wheat_color); 
  noStroke(); 
  rect(horMargin + 1, verMargin+348+2+50, 2, 15);
  fill(other_cereal_color); 
  noStroke(); 
  rect(horMargin + 1, verMargin+366+2+50, 2, 15);
  fill(vegitable_color); 
  noStroke(); 
  rect(horMargin + 1, verMargin+384+2+50, 2, 15);
  fill(oil_color); 
  noStroke(); 
  rect(horMargin + 1, verMargin+402+2+50, 2, 15);
  fill(sugar_color); 
  noStroke(); 
  rect(horMargin + 1, verMargin+420+2+50, 2, 15);

  fill(200);
  text("Unit: M.EUR", 
    horMargin + 6, height - verMargin);
  
  cam.endHUD();
  hint(ENABLE_DEPTH_TEST);
}